﻿#region Copyright (c) 2013-04, Olaf Kober <amarok.projects@gmail.com>
//================================================================================
//	Permission is hereby granted, free of charge, to any person obtaining a copy
//	of this software and associated documentation files (the "Software"), to deal
//	in the Software without restriction, including without limitation the rights
//	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//	copies of the Software, and to permit persons to whom the Software is
//	furnished to do so, subject to the following conditions:
//
//	The above copyright notice and this permission notice shall be included in
//	all copies or substantial portions of the Software.
//
//	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//	THE SOFTWARE.
//================================================================================
#endregion


namespace Amarok.Agents
{
	/// <summary>
	/// This type represents the base class for agent options that can be supplied to an agent on construction. 
	/// Agent options can be used to provide agent instances with individual configurations and settings.
	/// 
	/// In contrast, the agent environment is shared between multiple agent instances and provides access to 
	/// the services of the runtime environment.
	/// </summary>
	public class AgentOptions
	{
		#region ++ Public Static Interface ++

		// static data
		private static readonly AgentOptions sEmpty = new AgentOptions();


		/// <summary>
		/// Gets an instance of empty agent options.
		/// </summary>
		public static AgentOptions Empty
		{
			get
			{
				return sEmpty;
			}
		}

		#endregion

	}
}
