﻿#region Copyright (c) 07/16/2012, Olaf Kober <amarok.projects@gmail.com>
//================================================================================
//	Permission is hereby granted, free of charge, to any person obtaining a copy
//	of this software and associated documentation files (the "Software"), to deal
//	in the Software without restriction, including without limitation the rights
//	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//	copies of the Software, and to permit persons to whom the Software is
//	furnished to do so, subject to the following conditions:
//
//	The above copyright notice and this permission notice shall be included in
//	all copies or substantial portions of the Software.
//
//	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//	THE SOFTWARE.
//================================================================================
#endregion

using System;
using System.Globalization;
using System.Windows.Data;


namespace Amarok.Presentation
{
	/// <summary>
	/// Converts the given Boolean value to the negated Boolean value.
	/// 
	/// :: Convert
	/// True   ...  False
	/// False  ...  True
	/// 
	/// :: ConvertBack
	/// True   ...  False
	/// False  ...  True
	/// </summary>
	[ValueConversion(typeof(Boolean), typeof(Boolean))]
	public sealed class NotConverter : MarkupExtensionValueConverter<
		NotConverter,
		Boolean,
		Boolean>
	{
		/// <summary>
		/// </summary>
		protected override Object OnConvert(Boolean value, Type targetType, Object parameter, CultureInfo culture)
		{
			return !value;
		}

		/// <summary>
		/// </summary>
		protected override Object OnConvertBack(Boolean value, Type targetType, Object parameter, CultureInfo culture)
		{
			return !value;
		}

	}
}
