﻿#region Copyright (c) 11/27/2011, Olaf Kober <amarok.projects@gmail.com>
//================================================================================
//	Permission is hereby granted, free of charge, to any person obtaining a copy
//	of this software and associated documentation files (the "Software"), to deal
//	in the Software without restriction, including without limitation the rights
//	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//	copies of the Software, and to permit persons to whom the Software is
//	furnished to do so, subject to the following conditions:
//
//	The above copyright notice and this permission notice shall be included in
//	all copies or substantial portions of the Software.
//
//	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//	THE SOFTWARE.
//================================================================================
#endregion

using System.Reflection;


namespace Amarok.Presentation
{
	/// <summary>
	/// </summary>
	internal sealed class ViewActionHandlerInspector : HandlerInspector
	{
		/// <summary>
		/// </summary>
		/// <param name="methodInfo"></param>
		/// <returns></returns>
		public override HandlerInfo Inspect(MethodInfo methodInfo)
		{
			if (ViewActionHandlerAttribute.IsDefined(methodInfo) == false)
				return null;

			if (VerifyNotGeneric(methodInfo) == false)
				return null;

			var parameters = methodInfo.GetParameters();

			if (VerifyParameterCount(methodInfo, parameters) == false)
				return null;
			if (VerifyIsViewActionTypeParameter(methodInfo, parameters[0]) == false)
				return null;
			if (VerifyBooleanReturnType(methodInfo) == false)
				return null;

			return new ViewActionHandlerInfo(methodInfo, parameters[0]);
		}

	}
}
