﻿#region Copyright (c) 2012-10, Olaf Kober <amarok.projects@gmail.com>
//================================================================================
//	Permission is hereby granted, free of charge, to any person obtaining a copy
//	of this software and associated documentation files (the "Software"), to deal
//	in the Software without restriction, including without limitation the rights
//	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//	copies of the Software, and to permit persons to whom the Software is
//	furnished to do so, subject to the following conditions:
//
//	The above copyright notice and this permission notice shall be included in
//	all copies or substantial portions of the Software.
//
//	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//	THE SOFTWARE.
//================================================================================
#endregion

#if TESTS

using NUnit.Framework;


namespace Amarok
{
	[TestFixture]
	public class Test_TaskCompletionSource
	{
		[Test]
		public void Test_Usage()
		{
			var source = new TaskCompletionSource();

			Assert.That(source.InnerTaskCompletionSource, Is.Not.Null);
			Assert.That(source.Task, Is.Not.Null);
			Assert.That(source.InnerTaskCompletionSource.Task, Is.SameAs(source.Task));
			Assert.That(source.Task.IsCompleted, Is.False);
			Assert.That(source.Task.IsFaulted, Is.False);
			Assert.That(source.Task.IsCanceled, Is.False);

			source.SignalCompletion();

			Assert.That(source.InnerTaskCompletionSource, Is.Not.Null);
			Assert.That(source.Task, Is.Not.Null);
			Assert.That(source.InnerTaskCompletionSource.Task, Is.SameAs(source.Task));
			Assert.That(source.Task.IsCompleted, Is.True);
			Assert.That(source.Task.IsFaulted, Is.False);
			Assert.That(source.Task.IsCanceled, Is.False);

			source.SignalCompletion();

			Assert.That(source.InnerTaskCompletionSource, Is.Not.Null);
			Assert.That(source.Task, Is.Not.Null);
			Assert.That(source.InnerTaskCompletionSource.Task, Is.SameAs(source.Task));
			Assert.That(source.Task.IsCompleted, Is.True);
			Assert.That(source.Task.IsFaulted, Is.False);
			Assert.That(source.Task.IsCanceled, Is.False);
		}

	}
}

#endif
