﻿#region Copyright (c) 11/26/2011, Olaf Kober <amarok.projects@gmail.com>
//================================================================================
//	Permission is hereby granted, free of charge, to any person obtaining a copy
//	of this software and associated documentation files (the "Software"), to deal
//	in the Software without restriction, including without limitation the rights
//	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//	copies of the Software, and to permit persons to whom the Software is
//	furnished to do so, subject to the following conditions:
//
//	The above copyright notice and this permission notice shall be included in
//	all copies or substantial portions of the Software.
//
//	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//	THE SOFTWARE.
//================================================================================
#endregion

#if TESTS

using NUnit.Framework;


namespace Amarok.Presentation
{
	[TestFixture]
	public class Test_ShowMessageBoxActions
	{
		[Test]
		public void Test_ShowInformationMessageBoxAction()
		{
			var action = new ShowInformationMessageBoxAction("AAA_{0}_CCC", "TITLE", "BBB");

			Assert.That(action.Caption, Is.EqualTo("TITLE"));
			Assert.That(action.Message, Is.EqualTo("AAA_{0}_CCC"));
			Assert.That(action.Arguments, Has.Length.EqualTo(1));
			Assert.That(action.Arguments, Has.Member("BBB"));
		}

		[Test]
		public void Test_ShowWarningMessageBoxAction()
		{
			var action = new ShowWarningMessageBoxAction("AAA_{0}_CCC", "TITLE", "BBB");

			Assert.That(action.Caption, Is.EqualTo("TITLE"));
			Assert.That(action.Message, Is.EqualTo("AAA_{0}_CCC"));
			Assert.That(action.Arguments, Has.Length.EqualTo(1));
			Assert.That(action.Arguments, Has.Member("BBB"));
		}

		[Test]
		public void Test_ShowErrorMessageBoxAction()
		{
			var action = new ShowErrorMessageBoxAction("AAA_{0}_CCC", "TITLE", "BBB");

			Assert.That(action.Caption, Is.EqualTo("TITLE"));
			Assert.That(action.Message, Is.EqualTo("AAA_{0}_CCC"));
			Assert.That(action.Arguments, Has.Length.EqualTo(1));
			Assert.That(action.Arguments, Has.Member("BBB"));
		}

		[Test]
		public void Test_ShowConfirmationMessageBoxAction()
		{
			var action = new ShowConfirmationMessageBoxAction("AAA_{0}_CCC", "TITLE", "BBB");

			Assert.That(action.Caption, Is.EqualTo("TITLE"));
			Assert.That(action.Message, Is.EqualTo("AAA_{0}_CCC"));
			Assert.That(action.Arguments, Has.Length.EqualTo(1));
			Assert.That(action.Arguments, Has.Member("BBB"));
			Assert.That(action.Confirmed, Is.False);

			action.Confirmed = true;

			Assert.That(action.Confirmed, Is.True);
		}

	}
}

#endif
