﻿#region Copyright (c) 11/24/2011, Olaf Kober <amarok.projects@gmail.com>
//================================================================================
//	Permission is hereby granted, free of charge, to any person obtaining a copy
//	of this software and associated documentation files (the "Software"), to deal
//	in the Software without restriction, including without limitation the rights
//	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//	copies of the Software, and to permit persons to whom the Software is
//	furnished to do so, subject to the following conditions:
//
//	The above copyright notice and this permission notice shall be included in
//	all copies or substantial portions of the Software.
//
//	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//	THE SOFTWARE.
//================================================================================
#endregion

#if TESTS

using System;
using NUnit.Framework;


namespace Amarok.Presentation
{
	[TestFixture]
	public class Test_ViewActionRoutedEventArgs
	{
		[Test]
		public void Test_Construction()
		{
			var viewAction = new ShowInformationMessageBoxAction("MSG", "CAPTION");

			var args = new ViewActionRoutedEventArgs(
				ViewActionManager.ViewActionEvent,
				null,
				viewAction);

			Assert.That(args.Handled, Is.False);
			Assert.That(args.OriginalSource, Is.Null);
			Assert.That(args.RoutedEvent, Is.EqualTo(ViewActionManager.ViewActionEvent));
			Assert.That(args.Source, Is.Null);
			Assert.That(args.ViewAction, Is.SameAs(viewAction));
		}

		[Test]
		public void Test_Construction_NullViewAction()
		{
			Assert.Throws<ArgumentNullException>(() =>
				{
					var args = new ViewActionRoutedEventArgs(
						ViewActionManager.ViewActionEvent,
						null,
						null);
				});
		}

	}
}

#endif
